/*
//	Description: Demo Backlight Functions
//	File:		BacklightTest.cpp
//	Created:	Christian Apfel
//	Date:		20.01.2016
//
*/

#include "stdafx.h"
#include "BacklightTest.h"

using namespace std;

BacklightTest::BacklightTest()
{

}

BacklightTest::~BacklightTest()
{

}

// ****** Demo App Menu Functions ******

void BacklightTest::StartBacklightTest()
{
	int BACKLIGHT_TEST;
	int BACKLIGHT_LEVEL;
	int BACKLIGHT_TIME;
	int BACKLIGHT_ENABLE;
	char *cStatus = new char[20];
	bool bEnable;

	// Wait Loop for 0 to Exit
	do
	{
		cout << "---------------------------------" << endl;
		cout << "Select Backlight Test!" << endl;
		cout << "---------------------------------" << endl;
		cout << "1: Set Backlight Brightness" << endl;
		cout << "2: Set Backlight Suspend" << endl;
		cout << "0: Main Menu" << endl;
		cout << "---------------------------------" << endl;
		cout << "Enter Test Number: ";
		cin >> BACKLIGHT_TEST;

		switch(BACKLIGHT_TEST)
		{
		case 1:
			{
				cout << endl;
				cout << "Set Backlight Brightness Test" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter Backlight Level: (0 ... 255): ";
				cin >> BACKLIGHT_LEVEL;

				if(BACKLIGHT_LEVEL > 255)
				{
					cout << "Invalid Value!!! Value must be less than 256!!!" << endl;
					break;
				}

				if(BACKLIGHT_LEVEL < 0)
				{
					cout << "Invalid Value!!! Value must be greater than 0!!!" << endl;
					break;
				}

				if(SetBrightness(BACKLIGHT_LEVEL) == true)
				{
					cStatus = "Success";
				}
				else
				{
					cStatus = "Failed";
				}

				cout << "Set Backlight Brightness " << " is " << cStatus << "!!!" << endl;
				cout << "------------------------------------" << endl;
			}
			break;
		case 2:
			{
				cout << endl;
				cout << "Set Backlight Suspend Test" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter Backlight Suspend Time: (0 ... 360): ";
				cin >> BACKLIGHT_TIME;
				cout << "Enter Backlight Suspend Enable: (0 = On, 1 = Off): ";
				cin >> BACKLIGHT_ENABLE;

				if(BACKLIGHT_TIME < 0)
				{
					cout << "Backlight Suspend Time must be greater than 0 Seconds" << endl;
				}

				if(BACKLIGHT_TIME > 360)
				{
					cout << "Backlight Suspend Time must be less than 360 Seconds" << endl;
				}

				if(BACKLIGHT_ENABLE == 0)
				{
					bEnable = false;
				}
				else if(BACKLIGHT_ENABLE == 1)
				{
					bEnable = true;
				}
				else
				{
					cout << "Enter valid Option to Enable/Disable Backlight Suspend" << endl;
				}

				if(SetSuspend(BACKLIGHT_TIME, bEnable) == true)
				{
					cStatus = "Success";
				}
				else
				{
					cStatus = "Failed";
				}

				cout << "Set Backlight Suspend: " << " is " << cStatus << "!!!" << endl;
				cout << "------------------------------------" << endl;
			}
			break;
		case 0:
			{
				delete(cStatus);
				return;
			}
		default:
			{
				cout << "Not valid Test Function!!!" << endl;
			}
			break;
		}
	}while(1); //GPIO_PIN_TEST != 0);
}

// ****** Backlight Functions ******

bool BacklightTest::SetBrightness(int iLevel)
{
	if(!SetBacklightLevel(iLevel))
	{
		return false;
	}

	return true;
}

bool BacklightTest::SetSuspend(int iTimeout, bool bEnable)
{
	if(!SetBacklightSuspend(iTimeout, bEnable))
	{
		return false;
	}

	return true;
}