/*
//	Description: Demo CAN Functions
//	File:		CANTest.cpp
//	Created:	Christian Apfel
//	Date:		26.04.2017
//
*/

#include "stdafx.h"
#include "CANTest.h"

using namespace std;

CANTest::CANTest()
{

}

CANTest::~CANTest()
{

}

// ****** Demo App Menu Functions ******

void CANTest::StartCanTest()
{
	int CAN_TEST;
	int CAN_DEV_MODE;
	int CAN_DEV_ID;
	unsigned long CAN_DEV_FREQ;
	int CAN_DEV_MSG_PRIO;
	int CAN_DEV_MSG_COUNT;
	int CAN_DEV_FILTER_ID;
	int CAN_DEV_FILTER_ID_MASK;
	unsigned char CAN_SEND_DATA[100];
	unsigned char CAN_RECEIVE_DATA[50];
	unsigned char CAN_RECEIVE_PACKET_DATA[8];
	char *cStatus = new char[20];
	int iBytePackets = 0;
	int iByteLength = 0;
	unsigned long lDev_Bitrate;
		
	// Wait Loop for 0 to Exit
	do
	{
		memset(CAN_SEND_DATA, 0, sizeof(CAN_SEND_DATA));
		memset(CAN_RECEIVE_DATA, 0, sizeof(CAN_RECEIVE_DATA));
		iByteLength = 0;
		cout << "---------------------------------" << endl;
		cout << "Select CAN Test!" << endl;
		cout << "---------------------------------" << endl;
		cout << "1: Write Test" << endl;
		cout << "2: Read Test" << endl;
		cout << "3: Remote Write Test" << endl;
		cout << "4: Remote Read Test" << endl;
		cout << "5: Filter Write Test" << endl;
		cout << "6: Filter Read Test" << endl;
		cout << "0: Main Menu" << endl;
		cout << "---------------------------------" << endl;
		cout << "Enter Test Number: ";
		cin >> CAN_TEST;

		switch(CAN_TEST)
		{
		case 1:
			{
				cout << endl;
				cout << "CAN Write Test" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter CAN Mode (CAN Mode: 0 = Standard, 1 = Extended ): ";
				cin >> CAN_DEV_MODE;
				cout << "Enter CAN ID (CAN ID: 11bit -> max 0x1FF, 29bit -> max 0xFFFFFF ): ";
				cin >> std::hex >> CAN_DEV_ID;
				cout << "Enter CAN Frequency (20000 ... 1000000 (Bit/s)): ";
				cin >> std::dec >> CAN_DEV_FREQ;
				cout << "Enter CAN Message PRIO (0 ... 255): ";
				cin >> CAN_DEV_MSG_PRIO;
				cout << "Enter CAN Data (e.g. abc): ";
				cin >> CAN_SEND_DATA;

				if(CANWriteTest(DHCOM_CANModeEnum(CAN_DEV_MODE), CAN_DEV_FREQ, CAN_DEV_ID, CAN_DEV_MSG_PRIO, CAN_SEND_DATA) == true)
				{
					cStatus = "Success";
				}
				else
				{
					cStatus = "Failed";
				}

				cout << "CAN Write Test - Data: " << CAN_SEND_DATA << " Status: " << cStatus << "!!!" << endl;
				cout << "------------------------------------" << endl;
			}
			break;
		case 2:
			{
				cout << endl;
				cout << "CAN Read Test" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter CAN Mode (CAN Mode: 0 = Standard, 1 = Extended ): ";
				cin >> CAN_DEV_MODE;
				cout << "Enter CAN Frequency (20000 ... 1000000 (Bit/s)): ";
				cin >> std::dec >> CAN_DEV_FREQ;
				cout << "Enter CAN Data Length (1 ... 6): ";
				cin >> CAN_DEV_MSG_COUNT;

				if(CANReadTest(DHCOM_CANModeEnum(CAN_DEV_MODE), CAN_DEV_FREQ, &CAN_DEV_ID, CAN_DEV_MSG_COUNT, CAN_RECEIVE_DATA) == true)
				{
					cStatus = "Success";
				}
				else
				{
					cStatus = "Failed";
				}

				for(int i = 0; i < CAN_DEV_MSG_COUNT; i++)
				{
					memset(CAN_RECEIVE_PACKET_DATA, 0, sizeof(CAN_RECEIVE_PACKET_DATA));

					for(int j = 0; j < 8; j++)
					{
						CAN_RECEIVE_PACKET_DATA[j] = CAN_RECEIVE_DATA[iByteLength];
						iByteLength = iByteLength + 1;
					}

					wcout << "CAN Read Test - ID: 0x" << std::hex << CAN_DEV_ID << " - Data: 0x" << std::hex << CAN_RECEIVE_PACKET_DATA[0] << " 0x"<< std::hex << CAN_RECEIVE_PACKET_DATA[1] << " 0x" << std::hex << CAN_RECEIVE_PACKET_DATA[2] << " 0x"<< std::hex << CAN_RECEIVE_PACKET_DATA[3] << " 0x"<< std::hex << CAN_RECEIVE_PACKET_DATA[4] << " 0x"<< std::hex << CAN_RECEIVE_PACKET_DATA[5] << " 0x"<< std::hex << CAN_RECEIVE_PACKET_DATA[6] << " 0x"<< std::hex << CAN_RECEIVE_PACKET_DATA[7] << " Status: " << cStatus << "!!!" << endl;
				}
				cout << "------------------------------------" << endl;
			}
			break;
		case 3:
			{
				cout << endl;
				cout << "CAN Remote Write Test" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter CAN Mode (CAN Mode: 0 = Standard, 1 = Extended ): ";
				cin >> CAN_DEV_MODE;
				cout << "Enter CAN ID (CAN ID: 11bit -> max 0x1FF, 29bit -> max 0xFFFFFF ): ";
				cin >> std::hex >> CAN_DEV_ID;
				cout << "Enter CAN Frequency (20000 ... 1000000 (Bit/s)): ";
				cin >> std::dec >> CAN_DEV_FREQ;
				cout << "Enter CAN Message PRIO (0 ... 255): ";
				cin >> CAN_DEV_MSG_PRIO;
				cout << "Enter CAN Data (e.g. abc): ";
				cin >> CAN_SEND_DATA;

				if(CANRemoteWriteTest(DHCOM_CANModeEnum(CAN_DEV_MODE), CAN_DEV_FREQ, CAN_DEV_ID, CAN_DEV_MSG_PRIO, CAN_SEND_DATA) == true)
				{
					cStatus = "Success";
				}
				else
				{
					cStatus = "Failed";
				}

				cout << "CAN Remote Write Test - Data: " << CAN_SEND_DATA << " Status: " << cStatus << "!!!" << endl;
				cout << "------------------------------------" << endl;
			}
			break;
		case 4:
			{
				cout << endl;
				cout << "CAN Remote Read Test" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter CAN Mode (CAN Mode: 0 = Standard, 1 = Extended ): ";
				cin >> CAN_DEV_MODE;
				cout << "Enter CAN Frequency (20000 ... 1000000 (Bit/s)): ";
				cin >> std::dec >> CAN_DEV_FREQ;
				cout << "Enter CAN Data Length (1 ... 6): ";
				cin >> CAN_DEV_MSG_COUNT;

				if(CANRemoteReadTest(DHCOM_CANModeEnum(CAN_DEV_MODE), CAN_DEV_FREQ, &CAN_DEV_ID, CAN_DEV_MSG_COUNT, CAN_RECEIVE_DATA) == true)
				{
					cStatus = "Success";
				}
				else
				{
					cStatus = "Failed";
				}

				for(int i = 0; i < CAN_DEV_MSG_COUNT; i++)
				{
					for(int j = 0; j < 8; j++)
					{
						memset(CAN_RECEIVE_PACKET_DATA, 0, sizeof(CAN_RECEIVE_PACKET_DATA));
						CAN_RECEIVE_PACKET_DATA[j] = CAN_RECEIVE_DATA[iByteLength];
						iByteLength = iByteLength + 1;
					}

					wcout << "CAN Remote Read Test - ID: 0x" << std::hex << CAN_DEV_ID << " - Data: 0x" << std::hex << CAN_RECEIVE_PACKET_DATA[0] << " 0x"<< std::hex << CAN_RECEIVE_PACKET_DATA[1] << " 0x" << std::hex << CAN_RECEIVE_PACKET_DATA[2] << " 0x"<< std::hex << CAN_RECEIVE_PACKET_DATA[3] << " 0x"<< std::hex << CAN_RECEIVE_PACKET_DATA[4] << " 0x"<< std::hex << CAN_RECEIVE_PACKET_DATA[5] << " 0x"<< std::hex << CAN_RECEIVE_PACKET_DATA[6] << " 0x"<< std::hex << CAN_RECEIVE_PACKET_DATA[7] << " Status: " << cStatus << "!!!" << endl;
				}
				cout << "------------------------------------" << endl;
			}
			break;
		case 5:
			{
				cout << endl;
				cout << "CAN Filter Write Test" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter CAN Mode (CAN Mode: 0 = Standard, 1 = Extended ): ";
				cin >> CAN_DEV_MODE;
				cout << "Enter CAN ID (CAN ID: 11bit -> max 0x1FF, 29bit -> max 0xFFFFFF ): ";
				cin >> std::hex >> CAN_DEV_ID;
				cout << "Enter CAN Frequency (20000 ... 1000000 (Bit/s)): ";
				cin >> std::dec >> CAN_DEV_FREQ;
				cout << "Enter CAN Message PRIO (0 ... 255): ";
				cin >> CAN_DEV_MSG_PRIO;
				cout << "Enter CAN Message Filter (e.g. 0x25): ";
				cin >> std::hex >> CAN_DEV_FILTER_ID;
				cout << "Enter CAN Message Filter ID Mask (e.g. 0x1FF): ";
				cin >> std::hex >> CAN_DEV_FILTER_ID_MASK;
				cout << "Enter CAN Data (e.g. abc): ";
				cin >> CAN_SEND_DATA;

				if(CANFilterWriteTest(DHCOM_CANModeEnum(CAN_DEV_MODE), CAN_DEV_FREQ, CAN_DEV_ID, CAN_DEV_MSG_PRIO, CAN_DEV_FILTER_ID, CAN_DEV_FILTER_ID_MASK, CAN_SEND_DATA) == true)
				{
					cStatus = "Success";
				}
				else
				{
					cStatus = "Failed";
				}

				cout << "CAN Filter Write Test - Data: " << CAN_SEND_DATA << " Status: " << cStatus << "!!!" << endl;
				cout << "------------------------------------" << endl;
			}
			break;
		case 6:
			{
				cout << endl;
				cout << "CAN Filter Read Test" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter CAN Mode (CAN Mode: 0 = Standard, 1 = Extended ): ";
				cin >> CAN_DEV_MODE;
				cout << "Enter CAN Frequency (20000 ... 1000000 (Bit/s)): ";
				cin >> std::dec >> CAN_DEV_FREQ;
				cout << "Enter CAN Message Filter (e.g. 0x25): ";
				cin >> std::hex >> CAN_DEV_FILTER_ID;
				cout << "Enter CAN Message Filter ID Mask (e.g. 0x1FF): ";
				cin >> std::hex >> CAN_DEV_FILTER_ID_MASK;
				cout << "Enter CAN Data Length (1 ... 6): ";
				cin >> CAN_DEV_MSG_COUNT;

				if(CANFilterReadTest(DHCOM_CANModeEnum(CAN_DEV_MODE), CAN_DEV_FREQ, &CAN_DEV_ID, CAN_DEV_FILTER_ID, CAN_DEV_FILTER_ID_MASK, CAN_DEV_MSG_COUNT, CAN_RECEIVE_DATA) == true)
				{
					cStatus = "Success";
				}
				else
				{
					cStatus = "Failed";
				}

				for(int i = 0; i < CAN_DEV_MSG_COUNT; i++)
				{
					for(int j = 0; j < 8; j++)
					{
						memset(CAN_RECEIVE_PACKET_DATA, 0, sizeof(CAN_RECEIVE_PACKET_DATA));
						CAN_RECEIVE_PACKET_DATA[j] = CAN_RECEIVE_DATA[iByteLength];
						iByteLength = iByteLength + 1;
					}

					wcout << "CAN Filter Read Test - ID: 0x" << std::hex << CAN_DEV_ID << " - Data: 0x" << std::hex << CAN_RECEIVE_PACKET_DATA[0] << " 0x"<< std::hex << CAN_RECEIVE_PACKET_DATA[1] << " 0x" << std::hex << CAN_RECEIVE_PACKET_DATA[2] << " 0x"<< std::hex << CAN_RECEIVE_PACKET_DATA[3] << " 0x"<< std::hex << CAN_RECEIVE_PACKET_DATA[4] << " 0x"<< std::hex << CAN_RECEIVE_PACKET_DATA[5] << " 0x"<< std::hex << CAN_RECEIVE_PACKET_DATA[6] << " 0x"<< std::hex << CAN_RECEIVE_PACKET_DATA[7] << " Status: " << cStatus << "!!!" << endl;
				}
				cout << "------------------------------------" << endl;
			}
			break;
		case 0:
			{
				return;
			}
			break;
		default:
			{

			}
			break;
		}
	}while(1);
}

// ****** UART Functions ******

bool CANTest::CANWriteTest(DHCOM_CANModeEnum eCANMode, unsigned long lCANBitrate, int iCANID, unsigned char cCANPrio, unsigned char *cData)
{
	bool bTLPrio = false;
	ulong lMsgTimeout = 30000;
	bool bTXAbort = true;
	unsigned char cSendArray[50];
	int iDataLength = 0;
	int iByteCount = 0;
	int iPacketLength = 0;

	memset(cSendArray, 0, sizeof(cSendArray));

	// Calculate Buffer length
	iDataLength = strlen((const char*)cData);

	for(int i = 0; i < iDataLength; i++)
	{
		cSendArray[i] = ((cData[iByteCount] & 0xF) << 4) | (cData[iByteCount+1] & 0xF);
		iByteCount = iByteCount + 2;
	}

	// Calculate Message Buffer length
	iDataLength = strlen((const char*)cSendArray);
	iPacketLength = iDataLength / 8;

	// if data length written to next array
	if((iDataLength % 8) > 0)
	{
		iPacketLength++;
	}	

	if(CANOpen(DHCOM_CAN1, eCANMode) == true)
	{
		if(CANConfigureMode(DHCOM_CAN1, eCANMode, lCANBitrate, bTLPrio, false) == false)
		{
			CANClose(DHCOM_CAN1);
			return false;
		}

		if(CANConfigureMessage(DHCOM_CAN1, DHCOM_CAN_DATA, iCANID, cCANPrio, lMsgTimeout, bTXAbort) == false)
		{
			CANClose(DHCOM_CAN1);
			return false;
		}

		if(CANWrite(DHCOM_CAN1, cSendArray, iPacketLength) == true)
		{
			CANClose(DHCOM_CAN1);
			return true;
		}

		CANClose(DHCOM_CAN1);
	}

	cout << "CAN Write Test failed";

	return false;
}

bool CANTest::CANReadTest(DHCOM_CANModeEnum eCANMode, unsigned long lCANBitrate, int *iCANID, int iCount, unsigned char *cData)
{
	bool bTLPrio = false;
	ulong lMsgTimeout = 30000;
	int iDefMsgID = 0;
	bool bTXAbort = false;
	unsigned char cCANPrio = 0;
	int iFilterID = 0;
	int iFilterIDMask = 0;
	bool bFilterFormat = false;
	bool bFilterRemote = false;

	if(CANOpen(DHCOM_CAN1, eCANMode) == true)
	{
		if(CANConfigureMode(DHCOM_CAN1, eCANMode, lCANBitrate, bTLPrio, false) == false)
		{
			CANClose(DHCOM_CAN1);
			return false;
		}

		if(CANConfigureMessage(DHCOM_CAN1, DHCOM_CAN_DATA, iDefMsgID, cCANPrio, lMsgTimeout, bTXAbort) == false)
		{
			CANClose(DHCOM_CAN1);
			return false;
		}

		if(CANConfigureFilter(DHCOM_CAN1, iFilterID, iFilterIDMask, bFilterFormat, bFilterRemote) == false)
		{
			CANClose(DHCOM_CAN1);
			return false;
		}

		if(CANRead(DHCOM_CAN1, cData, iCount) == true)
		{
			CANClose(DHCOM_CAN1);

			CANGetMessageParameter(DHCOM_CAN1, iCANID);

			return true;
		}

		CANClose(DHCOM_CAN1);
	}

	cout << "CAN Read Test failed";

	return false;
}

bool CANTest::CANRemoteWriteTest(DHCOM_CANModeEnum eCANMode, unsigned long lCANBitrate, int iCANID, unsigned char cCANPrio, unsigned char *cData)
{
	bool bTLPrio = false;
	ulong lMsgTimeout = 30000;
	bool bTXAbort = true;
	unsigned char cSendArray[50];
	int iDataLength = 0;
	int iByteCount = 0;
	int iPacketLength = 0;

	memset(cSendArray, 0, sizeof(cSendArray));

	// Calculate Buffer length
	iDataLength = strlen((const char*)cData);

	for(int i = 0; i < iDataLength; i++)
	{
		cSendArray[i] = ((cData[iByteCount] & 0xF) << 4) | (cData[iByteCount+1] & 0xF);
		iByteCount = iByteCount + 2;
	}

	// Calculate Message Buffer length
	iDataLength = strlen((const char*)cSendArray);
	iPacketLength = iDataLength / 8;

	// if data length written to next array
	if((iDataLength % 8) > 0)
	{
		iPacketLength++;
	}

	if(CANOpen(DHCOM_CAN1, eCANMode) == true)
	{
		if(CANConfigureMode(DHCOM_CAN1, eCANMode, lCANBitrate, bTLPrio, false) == false)
		{
			CANClose(DHCOM_CAN1);
			return false;
		}

		if(CANConfigureMessage(DHCOM_CAN1, DHCOM_CAN_REMOTE, iCANID, cCANPrio, lMsgTimeout, bTXAbort) == false)
		{
			CANClose(DHCOM_CAN1);
			return false;
		}

		if(CANWrite(DHCOM_CAN1, cData, iPacketLength) == true)
		{
			CANClose(DHCOM_CAN1);
			return true;
		}

		CANClose(DHCOM_CAN1);
	}

	cout << "CAN Remote Write Test failed";

	return false;
}

bool CANTest::CANRemoteReadTest(DHCOM_CANModeEnum eCANMode, unsigned long lCANBitrate, int *iCANID, int iCount, unsigned char *cData)
{
	bool bTLPrio = false;
	ulong lMsgTimeout = 30000;
	int iDefMsgID = 0;
	bool bTXAbort = false;
	unsigned char cCANPrio = 0;
	int iFilterID = 0;
	int iFilterIDMask = 0;
	bool bFilterFormat = false;
	bool bFilterRemote = true;

	if(CANOpen(DHCOM_CAN1, eCANMode) == true)
	{
		if(CANConfigureMode(DHCOM_CAN1, eCANMode, lCANBitrate, bTLPrio, false) == false)
		{
			CANClose(DHCOM_CAN1);
			return false;
		}

		if(CANConfigureMessage(DHCOM_CAN1, DHCOM_CAN_DATA, iDefMsgID, cCANPrio, lMsgTimeout, bTXAbort) == false)
		{
			CANClose(DHCOM_CAN1);
			return false;
		}

		if(CANConfigureFilter(DHCOM_CAN1, iFilterID, iFilterIDMask, bFilterFormat, bFilterRemote) == false)
		{
			CANClose(DHCOM_CAN1);
			return false;
		}

		if(CANRead(DHCOM_CAN1, cData, iCount) == true)
		{
			CANGetMessageParameter(DHCOM_CAN1, iCANID);

			CANClose(DHCOM_CAN1);
			return true;
		}

		CANClose(DHCOM_CAN1);
	}

	cout << "CAN Remote Read Test failed";

	return false;
}

bool CANTest::CANFilterWriteTest(DHCOM_CANModeEnum eCANMode, unsigned long lCANBitrate, int iCANID, unsigned char cCANPrio, int iCANFilterID, int iCANFilterIDMask, unsigned char *cData)
{
	bool bTLPrio = false;
	ulong lMsgTimeout = 30000;
	int iFilterIDMask = 0x1FF;
	bool bFilterFormat = false;
	bool bFilterRemote = false;
	bool bTXAbort = true;
	unsigned char cSendArray[50];
	int iDataLength = 0;
	int iByteCount = 0;
	int iPacketLength = 0;

	memset(cSendArray, 0, sizeof(cSendArray));

	// Calculate Buffer length
	iDataLength = strlen((const char*)cData);

	for(int i = 0; i < iDataLength; i++)
	{
		cSendArray[i] = ((cData[iByteCount] & 0xF) << 4) | (cData[iByteCount+1] & 0xF);
		iByteCount = iByteCount + 2;
	}

	// Calculate Message Buffer length
	iDataLength = strlen((const char*)cSendArray);
	iPacketLength = iDataLength / 8;

	// if data length written to next array
	if((iDataLength % 8) > 0)
	{
		iPacketLength++;
	}

	if(CANOpen(DHCOM_CAN1, eCANMode) == true)
	{
		if(CANConfigureMode(DHCOM_CAN1, eCANMode, lCANBitrate, bTLPrio, false) == false)
		{
			CANClose(DHCOM_CAN1);
			return false;
		}

		if(CANConfigureFilter(DHCOM_CAN1, iCANFilterID, iFilterIDMask, bFilterFormat, bFilterRemote) == false)
		{
			return false;
		}

		if(CANConfigureMessage(DHCOM_CAN1, DHCOM_CAN_DATA, iCANID, cCANPrio, lMsgTimeout, bTXAbort) == false)
		{
			CANClose(DHCOM_CAN1);
			return false;
		}

		if(CANWrite(DHCOM_CAN1, cData, iPacketLength) == true)
		{
			if(CANResetFilter(DHCOM_CAN1) == true)
			{
				CANClose(DHCOM_CAN1);
				return true;
			}
		}

		CANClose(DHCOM_CAN1);
	}

	cout << "CAN Filter Write Test failed";

	return false;
}

bool CANTest::CANFilterReadTest(DHCOM_CANModeEnum eCANMode, unsigned long lCANBitrate, int *iCANID, int iCANFilterID, int iCANFilterIDMask, int iCount, unsigned char *cData)
{
	bool bTLPrio = false;
	ulong lMsgTimeout = 30000;
	int iDefMsgID = 0;
	bool bTXAbort = true;
	unsigned char cCANPrio = 0;
	bool bFilterFormat = false;
	bool bFilterRemote = false;

	if(CANOpen(DHCOM_CAN1, eCANMode) == true)
	{
		if(CANConfigureMode(DHCOM_CAN1, eCANMode, lCANBitrate, bTLPrio, false) == false)
		{
			CANClose(DHCOM_CAN1);
			return false;
		}

		if(CANConfigureMessage(DHCOM_CAN1, DHCOM_CAN_DATA, iDefMsgID, cCANPrio, lMsgTimeout, bTXAbort) == false)
		{
			CANClose(DHCOM_CAN1);
			return false;
		}

		if(CANConfigureFilter(DHCOM_CAN1, iCANFilterID, iCANFilterIDMask, bFilterFormat, bFilterRemote) == false)
		{
			return false;
		}

		if(CANRead(DHCOM_CAN1, cData, iCount) == true)
		{
			if(CANResetFilter(DHCOM_CAN1) == true)
			{
				CANGetMessageParameter(DHCOM_CAN1, iCANID);

				CANClose(DHCOM_CAN1);
				return true;
			}
		}

		CANClose(DHCOM_CAN1);
	}

	cout << "CAN Filter Read Test failed";

	return false;
}