/*
//	Description: Demo Physical Memory Functions
//	File:		MEMTest.cpp
//	Created:	Christian Apfel
//	Date:		15.12.2015
//
*/

#include "stdafx.h"
#include "MEMTest.h"

using namespace std;

MEMTest::MEMTest()
{

}

MEMTest::~MEMTest()
{

}

// ****** Demo App Menu Functions ******

void MEMTest::StartMemTest()
{
	int MEM_TEST;
	int MEM_REG_ADDRESS;
	int MEM_REG_ADDRESS_ARRAY[4];
	int MEM_REG_VALUE_ARRAY[4];
	int MEM_REG_VALUE;
	int MEM_RET_VALUE;
	int MEM_CHANNEL_VALUE;

	char *cStatus = new char[20];

	// Wait Loop for 0 to Exit
	do
	{
		cout << "---------------------------------" << endl;
		cout << "Select Gpio Test!" << endl;
		cout << "---------------------------------" << endl;
		cout << "1: Write Register Test" << endl;
		cout << "2: Read Register Test" << endl;
		cout << "3: Write and Return Register Test" << endl;
		cout << "4: Asyscron Write and Read Register Test" << endl;
		cout << "0: Main Menu" << endl;
		cout << "---------------------------------" << endl;
		cout << "Enter Test Number: ";
		cin >> MEM_TEST;

		switch(MEM_TEST)
		{
		case 1:
			{
				cout << endl;
				cout << "Write Register Test" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter Register Address (e.g. 0x0209c700): ";
				cin >> std::hex >> MEM_REG_ADDRESS;
				cout << "Enter Register Channel Pin (e.g. 1 to 9): ";
				cin >> std::hex >> MEM_CHANNEL_VALUE;
				cout << "Enter Register Value Pin (e.g. 0x1): ";
				cin >> std::hex >> MEM_REG_VALUE;

				if(WriteRegisterTest(MEM_CHANNEL_VALUE, MEM_REG_ADDRESS, MEM_REG_VALUE) == true)
				{
					strcpy(cStatus, "Success");
				}
				else
				{
					strcpy(cStatus, "Failed");
				}

				cout << "Memory Write Test Register: " << MEM_REG_ADDRESS << " | Value: " << std::hex << MEM_REG_VALUE << " | " << cStatus << "!!!" << endl;
				cout << "------------------------------------" << endl;
			}
			break;
		case 2:
			{
				cout << endl;
				cout << "Read Register Test" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter Register Address (e.g. 0x0209c700); ";
				cin >> std::hex >> MEM_REG_ADDRESS;
				cout << "Enter Register Channel Pin (e.g. 1 to 9): ";
				cin >> std::hex >> MEM_CHANNEL_VALUE;

				if(ReadRegisterTest(MEM_CHANNEL_VALUE, MEM_REG_ADDRESS, &MEM_RET_VALUE) == true)
				{
					strcpy(cStatus, "Success");
				}
				else
				{
					strcpy(cStatus, "Failed");
				}

				cout << "Memory Read Test Register: " << std::hex << MEM_REG_ADDRESS << " | Value: " << std::hex << MEM_RET_VALUE << " | " << cStatus << "!!!" << endl;
				cout << "------------------------------------" << endl;
			}
			break;
		case 3:
			{
				cout << endl;
				cout << "Write and Return Register Test" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter Register Address (e.g. 0x0209c700): ";
				cin >> std::hex >> MEM_REG_ADDRESS;
				cout << "Enter Register Channel Pin (e.g. 1 to 9): ";
				cin >> std::hex >> MEM_CHANNEL_VALUE;
				cout << "Enter Register Value Pin (e.g. 0x1): ";
				cin >> std::hex >> MEM_REG_VALUE;

				if(WriteBackRegisterTest(MEM_CHANNEL_VALUE, MEM_REG_ADDRESS, MEM_REG_VALUE, &MEM_RET_VALUE) == true)
				{
					if(MEM_REG_VALUE == MEM_RET_VALUE)
					{
						strcpy(cStatus, "Success");
					}
					else
					{
						strcpy(cStatus, "Failed");
					}
				}
				else
				{
					strcpy(cStatus, "Failed");
				}

				cout << "Memory Write Test Register: " << std::hex << "0x" << MEM_REG_ADDRESS << " | Value: " << std::hex << "0x" << MEM_REG_VALUE << " | Return " << std::hex << "0x" << MEM_RET_VALUE << " | " << cStatus << "!!!" << endl;
				cout << "------------------------------------" << endl;
			}
			break;
		case 4:
			{
				cout << endl;
				cout << "Asyscron Write and Read Register Test" << endl;
				cout << "------------------------------------" << endl;
				cout << "Use Channel 1 to 4" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter Register Address 1 (e.g. 0x0209c700): ";
				cin >> std::hex >> MEM_REG_ADDRESS_ARRAY[0];
				cout << "Enter Register Address 2(e.g. 0x0209c700): ";
				cin >> std::hex >> MEM_REG_ADDRESS_ARRAY[1];
				cout << "Enter Register Address 3(e.g. 0x0209c700): ";
				cin >> std::hex >> MEM_REG_ADDRESS_ARRAY[2];
				cout << "Enter Register Address 4(e.g. 0x0209c700): ";
				cin >> std::hex >> MEM_REG_ADDRESS_ARRAY[3];
				
				if(AsyncronReadRegister(MEM_REG_ADDRESS_ARRAY, MEM_REG_VALUE_ARRAY) == true)
				{
					strcpy(cStatus, "Success");
				}
				else
				{
					strcpy(cStatus, "Failed");
				}

				for(int i = 0; i < 4; i++)
				{
					cout << "Memory Write Read Asyncron Test Register " << i << ": " << std::hex << "0x" << MEM_REG_ADDRESS_ARRAY[i] << " | Return " << std::hex << "0x" << MEM_REG_VALUE_ARRAY[i] << " | " << cStatus << "!!!" << endl;
				}
				
				cout << "------------------------------------" << endl;
			}
			break;
		case 0:
			{
				delete(cStatus);
				return;
			}
		default:
			{
				cout << "Not valid Test Function!!!" << endl;
			}
			break;
		}
	}while(1);
}

// ****** Physical Memory Functions ******

bool MEMTest::WriteRegisterTest(int iChannel, int iPhyAddr, int iRegValue)
{
	cout << "Physical Write Channel: " << iChannel << endl;

	cout << "Physical Write Register: 0x" << std::hex << iPhyAddr << " - Register Value: 0x" << std::hex << iRegValue << endl;
	
	if(WritePhysicalAddress((DHCOM_PHYEnum)iChannel, iPhyAddr, 32, iRegValue, true) >= 0)
	{
		cout << "Physical Write Register : 0x" << iRegValue << endl;
		cout << "Physical Write successful" << endl;
		return true;
	}

	return false;
}

bool MEMTest::ReadRegisterTest(int iChannel, int iPhyAddr, int *iRegBackValue)
{
	cout << "Physical Read Channel: " << iChannel << endl;

	*iRegBackValue = ReadPhysicalAddress((DHCOM_PHYEnum)iChannel, iPhyAddr, 32);

	cout << "Physical Read Return: 0x" << std::hex << *iRegBackValue << endl;

	return true;
}

bool MEMTest::WriteBackRegisterTest(int iChannel, int iPhyAddr, int iRegValue, int *iRegBackValue)
{
	if((*iRegBackValue = WritePhysicalAddress((DHCOM_PHYEnum)iChannel, iPhyAddr, 32, iRegValue, true)) == iRegValue)
	{
		return true;
	}

	return false;
}

bool MEMTest::AsyncronReadRegister(int *iPhyAddr, int *iRegBackValue)
{
	HANDLE  hThreadArray[4];
	DWORD   dwThreadIdArray[4];
	PMYDATA pDataArray[4];

	for( int i=0; i<4; i++ )
    {
        // Allocate memory for thread data.

        pDataArray[i] = (PMYDATA) HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY,
                sizeof(MYDATA));

		if( pDataArray[i] == NULL )
        {
           // If the array allocation fails, the system is out of memory
           // so there is no point in trying to print an error message.
           // Just terminate execution.
            ExitProcess(2);
        }

        // Generate unique data for each thread to work with.

		pDataArray[i]->Channel = (i+1);
        pDataArray[i]->PhyAddr = *(iPhyAddr+i);
		//pDataArray[i]->RegBack = RegBackArray[i];

        // Create the thread to begin execution on its own.

        hThreadArray[i] = CreateThread( 
            NULL,                   // default security attributes
            0,                      // use default stack size  
            PHYMEM_READ_THREAD,	    // thread function name
            pDataArray[i],		    // argument to thread function 
            0,                      // use default creation flags 
            &dwThreadIdArray[i]);   // returns the thread identifier 


        // Check the return value for success.
        // If CreateThread fails, terminate execution. 
        // This will automatically clean up threads and memory. 

        if (hThreadArray[i] == NULL) 
        {
			ErrorHandler(TEXT("CreateThread"));
			ExitProcess(3);
        }
    } // End of main thread creation loop.

	// Wait until all threads have terminated.

    WaitForMultipleObjects(4, hThreadArray, TRUE, INFINITE);

    // Close all thread handles and free memory allocations.

    for(int i=0; i<4; i++)
    {
        CloseHandle(hThreadArray[i]);

		cout << "Phymem Read Thread Channel Return: 0x" << std::hex << pDataArray[i]->RegBack << endl;

		*(iRegBackValue+i) = pDataArray[i]->RegBack;

        if(pDataArray[i] != NULL)
        {
            HeapFree(GetProcessHeap(), 0, pDataArray[i]);
            pDataArray[i] = NULL;    // Ensure address is not reused.
        }
    }

	return true;
}

DWORD WINAPI PHYMEM_READ_THREAD( LPVOID lpParam )
{
	PMYDATA pDataArray;

	pDataArray = (PMYDATA)lpParam;

	printf("PHYMEM_READ_THREAD: Channel: %x | Address: %x\n", pDataArray->Channel, pDataArray->PhyAddr);

	pDataArray->RegBack = ReadPhysicalAddress((DHCOM_PHYEnum)(pDataArray->Channel), pDataArray->PhyAddr, 32);

	return 0;
}

void ErrorHandler(LPTSTR lpszFunction) 
{ 
    // Retrieve the system error message for the last-error code.

    LPVOID lpMsgBuf;
    LPVOID lpDisplayBuf;
    DWORD dw = GetLastError(); 

    FormatMessage(
        FORMAT_MESSAGE_ALLOCATE_BUFFER | 
        FORMAT_MESSAGE_FROM_SYSTEM |
        FORMAT_MESSAGE_IGNORE_INSERTS,
        NULL,
        dw,
        MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
        (LPTSTR) &lpMsgBuf,
        0, NULL );

    // Display the error message.

    lpDisplayBuf = (LPVOID)LocalAlloc(LMEM_ZEROINIT, 
        (lstrlen((LPCTSTR) lpMsgBuf) + lstrlen((LPCTSTR) lpszFunction) + 40) * sizeof(TCHAR)); 
    StringCchPrintf((LPTSTR)lpDisplayBuf, 
        LocalSize(lpDisplayBuf) / sizeof(TCHAR),
        TEXT("%s failed with error %d: %s"), 
        lpszFunction, dw, lpMsgBuf); 
    MessageBox(NULL, (LPCTSTR) lpDisplayBuf, TEXT("Error"), MB_OK); 

    // Free error-handling buffer allocations.

    LocalFree(lpMsgBuf);
    LocalFree(lpDisplayBuf);
}
